/// <reference types="node" />
import { EventEmitter } from 'events';
import { PostCollector, TikTokConstructor, Result, Challenge, UserData, MusicInfos } from '../types';
import { Downloader } from '../core';
export declare class TikTokScraper extends EventEmitter {
    private mainHost;
    private userAgent;
    private download;
    private filepath;
    private json2csvParser;
    private filetype;
    private input;
    private proxy;
    private number;
    private asyncDownload;
    private asyncScraping;
    private collector;
    private event;
    private scrapeType;
    private cli;
    private spinner;
    private byUserId;
    private storeHistory;
    private historyPath;
    private idStore;
    Downloader: Downloader;
    private storeValue;
    private maxCursor;
    private noWaterMark;
    private noDuplicates;
    private timeout;
    private bulk;
    private zip;
    private fileName;
    private test;
    private hdVideo;
    private signature;
    private webHookUrl;
    private method;
    private headers;
    private qs;
    private httpRequests;
    constructor({ download, filepath, filetype, proxy, asyncDownload, cli, event, progress, input, number, type, by_user_id, store_history, historyPath, userAgent, noWaterMark, fileName, timeout, bulk, zip, test, hdVideo, headers, signature, webHookUrl, method, qs }: TikTokConstructor);
    private get fileDestination();
    private get folderDestination();
    private get getProxy();
    private request;
    private returnInitError;
    scrape(): Promise<Result | any>;
    private withoutWatermark;
    private extractVideoId;
    private mainLoop;
    private submitScrapingRequest;
    private saveCollectorData;
    saveMetadata({ json, csv }: {
        json: any;
        csv: any;
    }): Promise<void>;
    private storeDownlodProgress;
    private collectPostsV2;
    private collectPosts;
    private scrapeData;
    private getTrendingFeedQuery;
    private getMusicFeedQuery;
    private getHashTagId;
    private getUserId;
    getUserProfileInfo(): Promise<UserData>;
    getHashtagInfo(): Promise<Challenge>;
    getMusicInfo(): Promise<MusicInfos>;
    signUrl(): Promise<any>;
    getVideoMeta(): Promise<PostCollector>;
    private sendDataToWebHookUrl;
}
